/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 03.02.2014
Author  : 
Company : 
Comments: 


Chip type               : ATmega328P
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/
#include <mega328p.h>
#include <delay.h>
#include <alcd.h>
#include <stdlib.h>

#define ENCA PINC.3
#define ENCB PINC.4
#define SET_B(x) |=(1<<x)
#define CLR_B(x) &=~(1<<x)
#define ATT PINB.1
#define RIT PINB.2
#define SN  PINB.3
#define TXI PINC.1

#define CLK PORTD.3
#define FQ PORTD.2
#define DATA PORTD.1
#define RES PORTD.0

unsigned long int freq;   // start freqensy
long int f_cont;
long int iff;             //if freqency

char __eeprom f_en;       //proshivka defoltov pri pervom starte
long int __eeprom eif;    //znachenie pch dlya eeproma
float __eeprom ek;        //koefficient dlya sintezatora, po umolchaniy 34.359738368 (dlya taktovogo 125.000.000 MHz)
long int __eeprom fdds;   //taktovaya chastota, po umolchaniy 125000000
unsigned long int __eeprom sfreq;  //konstanta startovoy chastoty

unsigned int shag = 1000; //shag po umolchaniu
char at = 0;
int ri =0;
bit ri0 = 0;
int sig = 0;
int time = 0;

bit if_setup=0;
bit if_read=0;
bit koeff_setup=0;
bit koeff_read=0;

bit tx = 0;
bit up1 = 1;             //1 stroka
bit up2 = 1;             //2 stroka
char ri_h[6];

char fr_k[16];           //  
char fr_h[6];            //  
int fr_buf_k;            //  
int fr_buf_h;            //  

static char enco;
static char encoo;

enum { State0, StateA, StateB, StateAB };

char b;
char i;
char sup=1;

union un_dataword                  //
{                                  //
unsigned long dataword_freq;       //  
unsigned char dataword_byte[5];    //
}un;                               //

float k;            //   = 4294967296 / F_DDS_IN


typedef unsigned char byte;

flash byte char0[8]={
0b0000000,
0b0000000,
0b0000000,
0b0000000,
0b0000000,
0b0000000,
0b0011011,
0b0000000};

flash byte char1[8]={
0b0000000,
0b0000000,
0b0000000,
0b0000000,
0b0000000,
0b0000011,
0b0011011,
0b0000000};

flash byte char2[8]={
0b0000000,
0b0000000,
0b0000000,
0b0000011,
0b0011011,
0b0011011,
0b0011011,
0b0000000};

flash byte char3[8]={
0b0000000,
0b0000011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0000000};

flash byte char4[8]={
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0000000};

flash byte char5[8]={
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0000000};

flash byte char7[8]={
0b0010101,
0b0010101,
0b0001110,
0b0000100,
0b0000100,
0b0000100,
0b0000100,
0b0000000};

flash byte char6[8]={
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0011011,
0b0000000};


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
time=time+1;
TCNT0=0x00;
}

#define ADC_VREF_TYPE 0xC0

// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
unsigned int adc_data;
// Read the AD conversion result
adc_data=ADCW;
sig=adc_data;
up2=1;
// Place your code here

}

void define_char(byte flash *pc,byte char_code) 
 { 
 byte i,a; 
 a=(char_code<<3)|0x40; 
 for (i=0; i<8; i++) lcd_write_byte(a++,*pc++); 
 } 
  
void Encoder_Init(void)
{
  enco = State0;       //????????????? ??????????? ?????????
  encoo = State0;   //????????????? ????-??????????? ?????????
}
 
void Encoder_Exe(void)
{
  char EncCur = 0;
  if(!ENCA) EncCur  = StateA; //????? ???? 1 ????????
  if(!ENCB) EncCur |= StateB; //????? ???? 2 ????????
  if(EncCur != enco)             //???? ????????? ??????????,
  {
    if(enco == StateAB &&        //???? ?????????? ????????? StateAB
       EncCur != encoo )      //? ??????? ? ????-?????????? ?? ?????,
    {
      if(EncCur == StateB) {          //???? ??????? ????????? StateB,
        if (ri0==0) {        
        freq = freq + shag;            //??? ?????
        up1 = 1; 
                   } else {
                                if (ri<4999) {
                                ri = ri + 100;
                                up1 = 1;     };
        };     
                   }
      else {                         //?????
        if (ri0==0) {        
        freq = freq - shag;            //??? ?????
        up1 = 1; 
                   } else {
                                if (ri>-4999) {
                                ri = ri - 100;
                                up1 = 1;      };
        };
             
                   };
           }
    encoo = enco;          //?????????? ????-??????????? ?????????
    enco = EncCur;               //?????????? ??????????? ?????????
  }
}

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x30;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=0 State1=T State0=T 
PORTC=0x00;
DDRC=0x04;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x01;

// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;

// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// USART initialization
// USART disabled
UCSR0B=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR1=0x00;

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
// ADC Auto Trigger Source: ADC Stopped
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
DIDR0=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x8B;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTB Bit 0
// RD - PORTD Bit 7
// EN - PORTD Bit 6
// D4 - PORTD Bit 5
// D5 - PORTB Bit 7
// D6 - PORTB Bit 6
// D7 - PORTD Bit 4
// Characters/line: 16
lcd_init(16);
define_char(char0,0); 
define_char(char1,1); 
define_char(char2,2); 
define_char(char3,3); 
define_char(char4,4);
define_char(char5,5);
define_char(char6,6); 
define_char(char7,7);

{
if (f_en==5) {
                lcd_gotoxy(0,0);
                lcd_putsf(" TRX Beta v.03a ");
                lcd_gotoxy(0,1);
                lcd_putsf("radiorubka.at.ua");
              } else {
                lcd_gotoxy(0,0);
                lcd_putsf(" TRX Beta v.03a ");
                lcd_gotoxy(0,1);
                lcd_putsf("  First Start   ");
                sfreq=6500000;
                eif=500000;
                fdds=125000000;
                ek=4294967296/fdds;
                f_en=5;
              };  

if (!RIT) {
        if_setup=1;
        lcd_gotoxy(0,0);
        lcd_putsf(" TRX Beta v.03a ");
        lcd_gotoxy(0,1);
        lcd_putsf("    IF Setup    ");
          } else {
        if_setup=0;
          };
          
if (!ATT) {
        koeff_setup=1;
        lcd_gotoxy(0,0);
        lcd_putsf(" TRX Beta v.03a ");
        lcd_gotoxy(0,1);
        lcd_putsf("DDS Q. Gen Setup");
          } else {
        koeff_setup=0;
          };
} 
  
Encoder_Init();
ADMUX CLR_B(0);   //
ADMUX CLR_B(1);   //    ( adc0)
ADMUX CLR_B(2);   //
ADMUX CLR_B(3);   //         
delay_ms(2000);
RES=1;
RES=0;
lcd_clear();

while (if_setup==1) {

if (if_read==0) {
                freq=eif;
                if_read=1;
                };
                                
if (up1 == 1) {
                        lcd_clear();
                        lcd_gotoxy(0,0);
                        
                        lcd_putsf ("IF = ");                                                  
                        
                        ltoa(freq, fr_k);     //
                        
                        lcd_puts (fr_k);          // 
                        lcd_putsf (" Hz");          // 
                        
                        up1 = 0;
                        up2 = 1;
                }
                        
 if (up2 == 1) {
                        lcd_gotoxy(0,1);
                        lcd_putsf("Edit ");
                        
                        if (shag == 1000) {
                        lcd_putsf (" 1 kHz");
                                          };
                        if (shag == 10000) {
                        lcd_putsf ("10 kHz");
                                          };
                        if (shag == 100) {
                        lcd_putsf ("100 Hz");
                                          };
                        if (shag == 50000) {
                        lcd_putsf ("50 kHz");
                                          };                                          
                        up2 = 0;                        
                        }
                        
                        Encoder_Exe();
                                    
       if (!SN) {
                        switch (shag) {
                        case 100: shag=1000; up2 = 1; delay_ms(300); break;
                        case 1000: shag=10000; up2 = 1; delay_ms(300); break;
                        case 10000: shag=50000; up2 = 1; delay_ms(300); break;
                        case 50000: shag=100; up2 = 1; delay_ms(300); break;
                                    };    
                                    };                                          
       if (!ATT) {
                        eif=freq;
                        up1=1;
                        up2=1;
                        shag=1000;
                        lcd_clear();
                        delay_ms(1000);
                        if_setup=0;
                 };
                        };

while (koeff_setup==1) {

if (koeff_read==0) {
                freq=fdds;
                koeff_read=1;
                };
                                
if (up1 == 1) {
                        lcd_gotoxy(0,0);
                        
                        lcd_putsf ("F = ");                                                  
                        
                        ltoa(freq, fr_k);     //
                        
                        lcd_puts (fr_k);          // 
                        lcd_putsf (" Hz");          // 
                        
                        up1 = 0;
                    
                }
                        
 if (up2 == 1) {
                        lcd_gotoxy(0,1);
                        lcd_putsf("Edit ");
                        
                        if (shag == 1000) {
                        lcd_putsf ("1  kHz");
                                          };
                        if (shag == 100) {
                        lcd_putsf ("100 Hz");
                                          };
                        if (shag == 10) {
                        lcd_putsf ("10  Hz");
                                          };
                        if (shag == 1) {
                        lcd_putsf ("1   Hz");
                                          };
                        up2 = 0;                        
                        }
                        
                        Encoder_Exe();
                                    
       if (!SN) {
                        switch (shag) {
                        case 100: shag=1000; up2 = 1; delay_ms(300); break;
                        case 1000: shag=1; up2 = 1; delay_ms(300); break;
                        case 1: shag=10; up2 = 1; delay_ms(300); break;
                        case 10: shag=100; up2 = 1; delay_ms(300); break;
                                    };    
                                    };                                          
       if (!RIT) {
                        fdds=freq;
                        delay_ms(100);
                        ek=4294967296/fdds;
                        delay_ms(100);
                        lcd_clear();
                        lcd_gotoxy(0,0); 
                        lcd_putsf ("  Koeff Verify  ");
                        freq=4294967296/ek;                                                                                                
                        ltoa(freq, fr_k);     // 
                        lcd_gotoxy(0,1);
                        lcd_putsf("   ");
                        lcd_puts (fr_k);          //  
                        delay_ms(3000);
                        up1=1;
                        up2=1;
                        shag=1000;
                        lcd_clear();
                        delay_ms(1000);
                        koeff_setup=0;
                 };
                        };
            
k=ek;
iff=eif;
freq=sfreq;

 

// Global enable interrupts
#asm("sei")

while (1)
      {
            //1 stroka
            if (up1 == 1) {
                        lcd_gotoxy(0,0);
                                                  
                        fr_buf_k = (freq/1000);     // 
                        fr_buf_h = (freq%1000)/100;     // 
                        
                        ltoa(fr_buf_k, fr_k);     //
                        ltoa(fr_buf_h, fr_h);     //  
                        
                        lcd_puts (fr_k);          // 
                        lcd_putsf (".");          // 
                        lcd_puts (fr_h);          // 
                        lcd_putsf (" ");                 // kHz
                        
                        if (ri0==0)       {
                        lcd_putsf ("AM ");                 // kHz
                        
                        if (shag == 1000) {
                        lcd_putsf (" 1 kHz");
                                          };
                        if (shag == 10000) {
                        lcd_putsf ("10 kHz");
                                          };
                        if (shag == 100) {
                        lcd_putsf ("100 Hz");
                                          };
                        if (shag == 500) {
                        lcd_putsf ("500 Hz");
                                          };
                        lcd_putsf ("");   
                                          } else {
                        
                        lcd_putsf ("R");
                        
                        ltoa(ri, ri_h);     //  
                        
                        if (ri==0) { 
                        lcd_putsf (" 0    Hz");
                                };
                        if (ri>0 & ri<=999) {
                        lcd_putsf (" ");
                        lcd_puts (ri_h);          // 
                        lcd_putsf ("  Hz"); 
                                };                                
                        if (ri>=1000 & ri<=9999) {
                        lcd_putsf (" ");
                        lcd_puts (ri_h);
                        lcd_putsf (" Hz");
                                             };
                        
                      if (ri<0 & ri>=-999) {
                      lcd_puts (ri_h);          // 
                      lcd_putsf ("  Hz"); 
                                            };
                      if (ri<=-1000 & ri>-9999) {
                      lcd_puts (ri_h);          // 
                      lcd_putsf (" Hz"); 
                                         };
                        
                                         };
                        
                        
                        
                        
                        
                        
                        up1 = 0;                      //   
                        sup = 1;
                        
                        };
                                                                  
            if (up2 == 1) {
                        if (tx == 0) {
                        lcd_gotoxy(0,1);
                        lcd_putsf("A ");
                        
                        if (at == 0) {
                        lcd_putsf("0ff ");
                                     };
                        if (at == 10) {
                        lcd_putsf("-10 ");
                                     };
                        if (at == 20) {
                        lcd_putsf("-20 ");
                                      };
                        if (at == 30) {
                        lcd_putsf("-30 ");
                                      };


                        
                        if (sig > 315)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putchar(0x03);
                        lcd_putchar(0x04);
                        lcd_putchar(0x05);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                                          };
                        if (sig > 280 & sig < 315)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putchar(0x03);
                        lcd_putchar(0x04);
                        lcd_putchar(0x05);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putsf(" ");
                                          };
                        if (sig > 245 & sig < 280)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putchar(0x03);
                        lcd_putchar(0x04);
                        lcd_putchar(0x05);
                        lcd_putchar(0x06);
                        lcd_putsf("  ");
                                          };
                        if (sig > 210 & sig < 245)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putchar(0x03);
                        lcd_putchar(0x04);
                        lcd_putchar(0x05);
                        lcd_putsf("   ");
                                          };
                        if (sig > 175 & sig < 210)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putchar(0x03);
                        lcd_putchar(0x04);
                        lcd_putsf("    ");
                                          };                        
                        if (sig > 140 & sig < 175)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putchar(0x03);
                        lcd_putsf("     ");
                                          };
                        if (sig > 105 & sig < 140)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putchar(0x02);
                        lcd_putsf("      ");
                                          };                        
                        if (sig > 70 & sig < 105)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putchar(0x01);
                        lcd_putsf("       ");
                                          };
                        if (sig > 35 & sig < 70)     {
                        lcd_putchar(0x07);
                        lcd_putchar(0x00);
                        lcd_putsf("        ");
                                          };
                        if (sig >= 0 & sig < 35)     {
                        lcd_putchar(0x07);
                        lcd_putsf("         ");
                                          };
                                       };
                        if (tx == 1) {
                        lcd_gotoxy(0,1);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putsf("[TX]");
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                        lcd_putchar(0x06);
                                      };
                        
                        up2 = 0;
                        sup = 1;
                        
                        };            
                       
            Encoder_Exe();
            
            if (time>10) {
            ADCSRA SET_B(6);
            time=0;
                          };
                                 
       if (!SN) {
                        switch (shag) {
                        case 100: shag=500; up1 = 1; delay_ms(300); break;
                        case 500: shag=1000; up1 = 1; delay_ms(300); break;
                        case 1000: shag=10000; up1 = 1; delay_ms(300); break;
                        case 10000: shag=100; up1 = 1; delay_ms(300); break;
                                    };    
                                    };  
       if (!ATT) {
                        switch (at)  {
                        case 0: at=10; up2 = 1; PORTB.4=0; PORTB.5=1; delay_ms(300); break; 
                        case 10: at=20; up2 = 1; PORTB.4=1; PORTB.5=0; delay_ms(300); break;
                        case 20: at=30; up2 = 1; PORTB.4=1; PORTB.5=1; delay_ms(300); break;
                        case 30: at=0; up2 = 1; PORTB.4=0; PORTB.5=0; delay_ms(300); break; 
                        };
                        };    
       if (!RIT) {
                        switch (ri0) {
                        case 0: ri0=1; up1 = 1; delay_ms(300); lcd_clear(); up2 = 1; break;
                        case 1: ri0=0; up1 = 1; ri=0; delay_ms(300); lcd_clear(); up2 = 1; break;
                        };
                        };
       if (!TXI & tx==0)        {
                        tx=1;
                        up2=1;
                        };
       if (TXI & tx==1) 
                        {
                        tx=0;
                        up2=1;
                        }; 
                        
       if (!RIT & !SN) {
                        #asm("cli");
                        sfreq=freq;
                        lcd_clear();
                        delay_ms(1000);
                        up1=1;
                        up2=2;
                        #asm("sei");
                        };                  
                        
       while (sup == 1) {   //,   
                          #asm ("cli");
                          if ( tx == 1 ) {                                   //    
                                         f_cont = freq;                  // ,    2 (  )
                                         } else {
                                         f_cont = freq+iff+ri;                // ,  
                                         };
                                         
                                         
                                         un.dataword_byte[4]=0b00000000;     //    (  )
                                         un.dataword_freq = f_cont*k;        //                                             
                                         
                                         FQ=1;                          //
                                         FQ=0;                          //  
                                         
                                         for (i=0; i<5; i++)                           //
                                                            {
                                                             for(b=0; b<8; b++){                
                                                             DATA = un.dataword_byte[i] & 1<<b;      //   
                                                             CLK = 1;                               // 
                                                             CLK = 0;
                                                             
                                                            };
                                                            };
                                         DATA = 0;                                            
                                         FQ=1;                                    //
                                         FQ=0;                                    //  
                                          
                                         sup = 0;                          //     .
                                         #asm ("sei");
                          };               
        
        
                                    
        
        
        
        
        
        
        
        
        
        
        
            
      }
}
